# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .address import Address
from .age import Age
from .annotation import Annotation
from .attachment import Attachment
from .codeable_concept import CodeableConcept
from .coding import Coding
from .contact_detail import ContactDetail
from .contact_point import ContactPoint
from .contributor import Contributor
from .count import Count
from .data_requirement import DataRequirement
from .data_requirement_code_filter import DataRequirementCodeFilter
from .data_requirement_date_filter import DataRequirementDateFilter
from .data_requirement_sort import DataRequirementSort
from .distance import Distance
from .dosage import Dosage
from .dosage_dose_and_rate import DosageDoseAndRate
from .duration import Duration
from .expression import Expression
from .extension import Extension
from .human_name import HumanName
from .identifier import Identifier
from .meta import Meta
from .money import Money
from .parameter_definition import ParameterDefinition
from .period import Period
from .quantity import Quantity
from .range import Range
from .ratio import Ratio
from .reference import Reference
from .related_artifact import RelatedArtifact
from .sampled_data import SampledData
from .signature import Signature
from .timing import Timing
from .timing_repeat import TimingRepeat
from .trigger_definition import TriggerDefinition
from .usage_context import UsageContext
import typing_extensions
import typing
from ...core.serialization import FieldMetadata
from .id import Id
import pydantic
from .uri import Uri
from .code import Code
from .identity_provider import IdentityProvider
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class ClientApplication(UniversalBaseModel):
    """
    Medplum client application for automated access.
    """

    resource_type: typing_extensions.Annotated[
        typing.Literal["ClientApplication"], FieldMetadata(alias="resourceType")
    ] = "ClientApplication"
    id: typing.Optional[Id] = pydantic.Field(default=None)
    """
    The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes.
    """

    meta: typing.Optional[Meta] = pydantic.Field(default=None)
    """
    The metadata about the resource. This is content that is maintained by the infrastructure. Changes to the content might not always be associated with version changes to the resource.
    """

    implicit_rules: typing_extensions.Annotated[
        typing.Optional[Uri], FieldMetadata(alias="implicitRules")
    ] = pydantic.Field(default=None)
    """
    A reference to a set of rules that were followed when the resource was constructed, and which must be understood when processing the content. Often, this is a reference to an implementation guide that defines the special rules along with other profiles etc.
    """

    language: typing.Optional[Code] = pydantic.Field(default=None)
    """
    The base language in which the resource is written.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    A name associated with the ClientApplication.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    A summary, characterization or explanation of the ClientApplication.
    """

    secret: typing.Optional[str] = pydantic.Field(default=None)
    """
    Client secret string used to verify the identity of a client.
    """

    jwks_uri: typing_extensions.Annotated[
        typing.Optional[Uri], FieldMetadata(alias="jwksUri")
    ] = pydantic.Field(default=None)
    """
    Optional JWKS URI for public key verification of JWTs issued by the authorization server (client_secret_jwt).
    """

    redirect_uri: typing_extensions.Annotated[
        typing.Optional[Uri], FieldMetadata(alias="redirectUri")
    ] = pydantic.Field(default=None)
    """
    Optional redirect URI used when redirecting a client back to the client application.
    """

    launch_uri: typing_extensions.Annotated[
        typing.Optional[Uri], FieldMetadata(alias="launchUri")
    ] = pydantic.Field(default=None)
    """
    Optional launch URI for SMART EHR launch sequence.
    """

    pkce_optional: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="pkceOptional")
    ] = pydantic.Field(default=None)
    """
    Flag to make PKCE optional for this client application. PKCE is required by default for compliance with Smart App Launch. It can be disabled for compatibility with legacy client applications.
    """

    identity_provider: typing_extensions.Annotated[
        typing.Optional[IdentityProvider], FieldMetadata(alias="identityProvider")
    ] = pydantic.Field(default=None)
    """
    Optional external Identity Provider (IdP) for the client application.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
