# This file was auto-generated by Fern from our API Definition.

from ....core.pydantic_utilities import UniversalBaseModel
from .document_query_status import DocumentQueryStatus
import pydantic
import typing_extensions
import typing
from ....core.serialization import FieldMetadata
from ....core.pydantic_utilities import IS_PYDANTIC_V2


class BulkGetDocumentUrlQuery(UniversalBaseModel):
    """
    Examples
    --------
    from metriport.medical.document import BulkGetDocumentUrlQuery

    BulkGetDocumentUrlQuery(
        status="processing",
        request_id="018c1e9d-dfce-70cb-8c0e-edfbbd2a7f5f",
    )
    """

    status: DocumentQueryStatus = pydantic.Field()
    """
    The status of the URL generation process.
    """

    request_id: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="requestId")
    ] = pydantic.Field(default=None)
    """
    The ID of the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
