# This file was auto-generated by Fern from our API Definition.

from ....core.pydantic_utilities import UniversalBaseModel
from .document_query_status import DocumentQueryStatus
import pydantic
import typing
from ....core.pydantic_utilities import IS_PYDANTIC_V2


class Progress(UniversalBaseModel):
    """
    Examples
    --------
    from metriport.medical.document import Progress

    Progress(
        status="processing",
    )
    """

    status: DocumentQueryStatus = pydantic.Field()
    """
    The status of querying document references across HIEs.
    """

    total: typing.Optional[int] = pydantic.Field(default=None)
    """
    The total number of documents to be queried.
    """

    successful: typing.Optional[int] = pydantic.Field(default=None)
    """
    The number of documents successfully downloaded.
    """

    errors: typing.Optional[int] = pydantic.Field(default=None)
    """
    The number of documents that failed to download.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
